#! /usr/bin/perl -w
#use strict;

my $startfrom = 0x1;

use constant { FORK => 1, EXEC => 2 };

# Set up data structure
my @creds;


while (<>) {
	if (m/\[([[:xdigit:]]+)\] credfork ([[:xdigit:]]+)/) {
		push @{ $creds[hex($1)]{events} }, { type => FORK, id => hex($2) };
	} elsif (m/\[([[:xdigit:]]+)\] credfree/) {
		# Free the index ($1) associated with this
	} elsif (m/\[([[:xdigit:]]+)\] exec (.*)$/) {
		push @{ $creds[hex($1)]{events} }, { type => EXEC, exec_args => $2 };
	}
}

my $nodenum = 0;

sub printrec(\@$$);
sub printrec(\@$$) {
	my @ary = @{ $_[0] };
	return if !$ary[$_[1]];
	my %record = %{ $ary[$_[1]] };
	return if !$record{events};
	my @evts = @{ $record{events} };
	my $prefix = $_[2];

	my $lasti = $#evts;
	for (my $i = 0; $i <= $lasti; $i++) {
		my %h = %{ $evts[$i] };
		#print $prefix;
		if ($h{type} == FORK) {
			$nodenum++;
			printf "   node%d[label=\"%s\"];\n", $nodenum, $h{id};
			printf "   node%d -> node%d;\n", $record{cur_node}, $nodenum;
			$ary[$h{id}]{cur_node} = $nodenum;
			#printf "+-%x\n", $h{id};
			if ($i == $lasti) {
				printrec @ary, $h{id}, $prefix . "  ";
			} else {
				printrec @ary, $h{id}, $prefix . "| ";
			}
		} elsif ($h{type} == EXEC) {
			$nodenum++;
			$cmd = $h{exec_args};
			$cmd =~ s/"/\\"/g;
			printf "   node%d[label=\"%s\",shape=box,margin=\"0.04,0\"];\n", $nodenum, $cmd;
			printf "   node%d -> node%d;\n", $record{cur_node}, $nodenum;
			$record{cur_node} = $nodenum;
			#print "+ exec $h{exec_args}\n";
		}
	}
}

print "digraph test {\n";
print "   page=\"11,8.5\"\n";
print "   pagedir=\"TL\"\n";
print "   node [shape=circle,height=0.02,margin=\"0.04,0.02\",fontsize=5.0,penwidth=0.1];\n";
print "   edge [penwidth=0.1,arrowsize=0.2];\n";

$creds[$startfrom]{cur_node} = 1;
printrec @creds, $startfrom, '';
print "}\n";
